'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DataFile = undefined;

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _data_source = require('./data_source');

var _data_source2 = _interopRequireDefault(_data_source);

var _clone = require('lodash/clone');

var _clone2 = _interopRequireDefault(_clone);

var _omitBy = require('lodash/omitBy');

var _omitBy2 = _interopRequireDefault(_omitBy);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EXTENSIONS = ['js', 'json', 'yaml', 'yml', 'csv'];
var GLOB = '**/*.{' + EXTENSIONS.join(',') + '}';
var SECRET_REGEX = /(secret|secure|secured|hidden|private)/i;

var DataFile = exports.DataFile = (function (_DataSource) {
  (0, _inherits3.default)(DataFile, _DataSource);
  (0, _createClass3.default)(DataFile, null, [{
    key: 'decorateCollection',
    value: function decorateCollection(collection) {
      defineProperty(collection, 'resolvePath', {
        enumerable: true,
        configurable: false,
        value: function value(path) {
          var parts = path.split('.');

          var match = undefined;

          while (!match && parts.length > 0) {
            match = collection.at(parts.join('/'));
            parts.pop();
          }

          return match;
        }
      });
    }
  }]);

  function DataFile(uri) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
    (0, _classCallCheck3.default)(this, DataFile);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(DataFile).call(this, uri, options));

    _this.indexer = parseSettings.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(DataFile, [{
    key: 'set',
    value: (function (_set) {
      function set(_x, _x2) {
        return _set.apply(this, arguments);
      }

      set.toString = function () {
        return _set.toString();
      };

      return set;
    })(function (key, value) {
      var _this2 = this;

      if (!value && isObject(key)) {
        (0, _keys2.default)(key).forEach(function (k) {
          _this2.set(k, key[k]);
        });
        return this;
      }

      if (isString(key) && !key.match(SECRET_REGEX)) {
        set(this.parsed, key, value);
      }

      return this;
    })
    /*
     * This lets us write less nested
     * versions of a settings file
     */

  }, {
    key: 'getData',
    value: function getData() {
      if (this.extension !== '.js' && (!this.raw || this.raw.length === 0)) {
        this.readSync();
      }

      var value = this.indexed;
      var parts = this.id.split('/');
      var last = parts[parts.length - 1];

      /**
       * If the settings yaml has a single key whose value
       * is the name of the settings file, we will use the value
       * at that key instead of the redundant nesting
       */
      if (value[last] && keys(value).length === 1) {
        value = value[last] || {};
      }

      return value;
    }
  }]);
  return DataFile;
})(_data_source2.default);

DataFile.EXTENSIONS = EXTENSIONS;
DataFile.GLOB = GLOB;
exports.default = DataFile;

function interpolateValues(obj, template) {
  var datasource = this;

  (0, _keys2.default)(obj).filter(function (key) {
    return !key.match(SECRET_REGEX);
  }).forEach(function (key) {
    var value = obj[key];

    if ((typeof value === 'undefined' ? 'undefined' : (0, _typeof3.default)(value)) === 'object') {
      interpolateValues.call(datasource, value, template);
    } else if (typeof value === 'string' && value.match(/^env\.\w+$/i)) {
      value = '<%= process.' + value + ' %>';
      obj[key] = template(value)(value);
    } else if (typeof value === 'string') {
      obj[key] = template(value)(value);
    }
  });

  return obj;
}

function parseSettings() {
  var val = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var base = interpolateValues.call(this, (0, _clone2.default)(val), this.templater.bind(this));

  return (0, _omitBy2.default)(base, function (v, k) {
    return k.match(SECRET_REGEX);
  });
}

var _Object = Object;
var defineProperty = _Object.defineProperty;
var keys = _Object.keys;