'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AssetManifest = AssetManifest;
function AssetManifest() {
  var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var project = options.project = options.project || this;

  if (options.project && !options.asset) {
    var re = ProjectExporter.call(options.project, options);
    return re;
  }

  if (options.asset) {
    return AssetExporter.call(options.asset, options);
  }
}

function ProjectExporter() {
  var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var project = options.project;

  return project.mapCollections(function (c) {
    return c.transform(function () {
      var result = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
      var asset = arguments[1];

      result[asset.paths.projectRequire] = AssetExporter({ asset: asset });
      return result;
    });
  });
}

function AssetExporter() {
  var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var asset = options.asset || this;

  var pick = require('../util').pick;
  var lodashify = require('../util').lodashify('pick', 'pickBy', 'omit', 'omitBy', 'get', 'set', 'keys', 'values');

  asset.readSync();

  return lodashify(pick(asset, 'id', 'uri', 'fingerprint', 'loaderString', 'paths'));
}

exports.default = AssetManifest;