'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.operators = exports.dotpath = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _getOwnPropertyNames = require('babel-runtime/core-js/object/get-own-property-names');

var _getOwnPropertyNames2 = _interopRequireDefault(_getOwnPropertyNames);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.humanize = humanize;
exports.titleize = titleize;
exports.classify = classify;
exports.tableize = tableize;
exports.underscore = underscore;
exports.parameterize = parameterize;
exports.slugify = slugify;
exports.singularize = singularize;
exports.pluralize = pluralize;
exports.promiseHash = promiseHash;
exports.execOutputAsync = execOutputAsync;
exports.lazy = lazy;
exports.flatten = flatten;
exports.singularize = singularize;
exports.createDelegators = createDelegators;
exports.values = values;
exports.mixin = mixin;
exports.access = access;
exports.runWithLocals = runWithLocals;
exports.noConflict = noConflict;
exports.carve = carve;
exports.isDomain = isDomain;
exports.isPromise = isPromise;
exports.isArray = isArray;
exports.isRegex = isRegex;
exports.filterQuery = filterQuery;
exports.abort = abort;
exports.findPackageSync = findPackageSync;
exports.findPackage = findPackage;
exports.splitPath = splitPath;
exports.skypagerBabel = skypagerBabel;
exports.pathExists = pathExists;
exports.findPackageManifest = findPackageManifest;
exports.loadManifestFromDirectory = loadManifestFromDirectory;

var _path = require('path');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _utile = require('utile');

var _utile2 = _interopRequireDefault(_utile);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _Object = Object;
var defineProperty = _Object.defineProperty;
var set = _lodash2.default.set;
var get = _lodash2.default.get;
var template = _lodash2.default.template;
var templateSettings = _lodash2.default.templateSettings;
var kebabCase = _lodash2.default.kebabCase;
var some = _lodash2.default.some;
var defaults = _lodash2.default.defaults;
var defaultsDeep = _lodash2.default.defaultsDeep;
var result = _lodash2.default.result;
var pick = _lodash2.default.pick;
var has = _lodash2.default.has;
var hasIn = _lodash2.default.hasIn;
var cloneDeep = _lodash2.default.cloneDeep;
var clone = _lodash2.default.clone;
var isEqual = _lodash2.default.isEqual;
var eq = _lodash2.default.eq;
var isMatch = _lodash2.default.isMatch;
var lt = _lodash2.default.lt;
var lte = _lodash2.default.lte;
var gt = _lodash2.default.gt;
var gte = _lodash2.default.gte;
var isEmpty = _lodash2.default.isEmpty;
var isObject = _lodash2.default.isObject;
var isString = _lodash2.default.isString;
var isNumber = _lodash2.default.isNumber;
var castArray = _lodash2.default.castArray;

var inflections = _utile2.default.inflect;
var DOMAIN_REGEX = /^[a-zA-Z0-9_-]+\.[.a-zA-Z0-9_-]+$/;

var dotpath = exports.dotpath = {
  set: set, get: get
};

var equals = eq;
var not_equals = function not_equals() {
  return !eq.apply(undefined, arguments);
};
var neq = function neq() {
  return !eq.apply(undefined, arguments);
};

var operators = exports.operators = {
  lt: lt, gt: gt, gte: gte, lte: lte, eq: eq, neq: neq, equals: equals, not_equals: not_equals
};

module.exports.assign = _objectAssign2.default;
module.exports.defaults = defaultsDeep;
module.exports.pick = pick;
module.exports.some = some;
module.exports.any = some;
module.exports.result = result;
module.exports.clone = cloneDeep;
module.exports.template = template;
module.exports.isObject = isObject;
module.exports.isNumber = isNumber;
module.exports.isString = isString;
module.exports.lodash = _lodash2.default;

var hidden = {
  getter: function getter(target, name, fn) {
    var configurable = arguments.length <= 3 || arguments[3] === undefined ? false : arguments[3];

    defineProperty(target, name, {
      configurable: configurable,
      enumerable: false,
      get: function get() {
        return typeof fn === 'function' ? fn.call(target) : fn;
      }
    });

    return target;
  },

  property: function property(target, name, value) {
    var configurable = arguments.length <= 3 || arguments[3] === undefined ? false : arguments[3];

    defineProperty(target, name, {
      configurable: configurable,
      enumerable: false,
      value: value
    });

    return target;
  }
};

module.exports.hidden = hidden;
module.exports.hide = hidden;

function humanize(s) {
  return inflections.humanize(s).replace(/-|_/g, ' ');
}

function titleize(s) {
  return inflections.titleize(humanize(s));
}

function classify(s) {
  return inflections.classify(s);
}

function tableize(s) {
  return inflections.tableize(s);
}

function underscore(s) {
  return tableize(s);
}

function parameterize(s) {
  s = s.replace(/\\|\//g, '-', '');
  s = s.replace(/[^-\w\s]/g, ''); // remove unneeded chars
  s = s.replace(/^\s+|\s+$/g, ''); // trim leading/trailing spaces
  s = s.replace(/[-\s]+/g, '-'); // convert spaces to hyphens
  s = s.toLowerCase(); // convert to lowercase
  return s;
}

function slugify(s) {
  return parameterize(s);
}

function singularize(word) {
  return inflections.singularize(word);
}

function pluralize(word) {
  return inflections.pluralize(word);
}

// thanks cheever
function promiseHash(obj) {
  var awaitables = [];

  var keys = (0, _keys2.default)(obj);
  for (var i = 0; i < keys.length; i++) {
    var key = keys[i];
    var a$ = obj[key];
    awaitables.push(a$);
  }
  return _promise2.default.all(awaitables).then(function (results) {
    var byName = {};
    for (var i = 0; i < keys.length; i++) {
      var key = keys[i];
      byName[key] = results[i];
    }
    return byName;
  });
}

function execOutputAsync(command) {
  var cwd = arguments.length <= 1 || arguments[1] === undefined ? process.env.PWD : arguments[1];
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  var exec = require('child_process').exec;

  return new _promise2.default(function (resolve, reject) {
    exec(command, (0, _extends3.default)({ cwd: cwd }, options), function (err, stdout, stderr) {
      if (err) {
        reject(err);
      } else {
        resolve(stdout.trim());
      }
    });
  });
}

function lazy(target, attribute, fn) {
  var enumerable = arguments.length <= 3 || arguments[3] === undefined ? false : arguments[3];

  defineProperty(target, attribute, {
    configurable: true,
    enumerable: enumerable,
    get: function get() {
      delete target[attribute];

      if (enumerable) {
        return target[attribute] = fn.call(target);
      } else {
        var value = fn.call(target);

        defineProperty(target, attribute, {
          enumerable: false,
          configurable: true,
          value: value
        });

        return value;
      }
    }
  });
}

function flatten(array) {
  return array.reduce(function (a, b) {
    return a.concat(b);
  }, []);
}

function singularize(string) {
  return inflections.singularize(string);
}

function createDelegators(target, source) {
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  var excludeKeys = options.exclude || options.except || [];
  var sourceKeys = (0, _keys2.default)(source).filter(function (key) {
    return excludeKeys.indexOf(key) === -1;
  });

  sourceKeys.forEach(function (key) {
    return defineProperty(target, key, {
      get: function get() {
        return source[key];
      }
    });
  });
}

function values(object) {
  return (0, _keys2.default)(object).map(function (key) {
    return object[key];
  });
}

function mixin(target, source) {
  target = target.prototype;source = source.prototype;

  (0, _getOwnPropertyNames2.default)(source).forEach(function (name) {
    if (name !== 'constructor') defineProperty(target, name, (0, _getOwnPropertyDescriptor2.default)(source, name));
  });
}

function access(object, dotted) {
  return get(object, dotted);
}

function runWithLocals(fn) {
  var locals = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  return new _promise2.default(function (resolve, reject) {
    noConflict(fn, locals, undefined, resolve, reject)();
  });
}

function noConflict(fn) {
  var provider = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
  var scope = arguments[2];
  var onSuccess = arguments[3];
  var onError = arguments[4];

  invariant(fn, 'provide a function');
  invariant(provider, 'provide a provider');

  var safe = {};

  return function () {
    (0, _keys2.default)(provider).forEach(function (globalProp) {
      if (global.hasOwnProperty(globalProp)) {
        var descriptor = (0, _getOwnPropertyDescriptor2.default)(global, globalProp);

        if (descriptor && descriptor.configurable) {
          defineProperty(safe, globalProp, descriptor);
        }
      }

      if (onSuccess) {}

      defineProperty(global, globalProp, (0, _getOwnPropertyDescriptor2.default)(provider, globalProp));
    });

    var result = undefined;
    var err = undefined;

    try {
      if (onSuccess) {}

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      result = scope ? fn.call.apply(fn, [scope].concat(args)) : fn.apply(undefined, args);
    } catch (e) {
      err = e;
    }

    (0, _keys2.default)(provider).forEach(function (remove) {
      return delete global[remove];
    });

    (0, _keys2.default)(safe).forEach(function (restore) {
      delete global[restore];
      (0, _defineProperty2.default)(global, restore, (0, _getOwnPropertyDescriptor2.default)(safe, restore));
    });

    if (err) {
      typeof onError === 'function' && onError(err);
      throw err;
    }

    typeof onSuccess === 'function' && onSuccess(err);
    return result;
  };
}

function carve(dataPath, resultValue) {
  var initialValue = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  dotpath.set(initialValue, dataPath, resultValue);
  return initialValue;
}

function isDomain(value) {
  return value.match(DOMAIN_REGEX);
}

function isPromise(obj) {
  return !!obj && ((typeof obj === 'undefined' ? 'undefined' : (0, _typeof3.default)(obj)) === 'object' || typeof obj === 'function') && typeof obj.then === 'function';
}

function isArray(arg) {
  return Object.prototype.toString.call(arg) === '[object Array]';
}

function isRegex(val) {
  if ((typeof val === 'undefined' ? 'undefined' : typeof val === 'undefined' ? 'undefined' : (0, _typeof3.default)(val)) === 'object' && (0, _getPrototypeOf2.default)(val).toString() === '/(?:)/') {
    return true;
  }

  return false;
}

function filterQuery() {
  var nodeList = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];
  var params = arguments[1];
  var negate = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

  if (typeof params === 'function') {
    return nodeList.filter(params);
  }

  var items = nodeList || [];

  return items.filter(function (node) {
    var matchesParam = (0, _keys2.default)(params).every(function (key) {
      var param = params[key];
      var value = result(node, key);

      if (isRegex(param) && param.test(value)) {
        return true;
      }

      if (typeof param === 'string' && value === param) {
        return true;
      }

      if (typeof param === 'number' && value === param) {
        return true;
      }

      // treat normal arrays to search for some exact matches
      if (isArray(param) && (isString(value) || isNumber(value))) {
        return some(param, function (val) {
          return val === value;
        });
      }

      if (isObject(param) && (param.value || param.val) && (param.op || param.operator)) {
        return testWithOperator(param, value);
      }

      if (isObject(param) && isObject(value)) {
        return isMatch(value, param);
      }
    });

    return negate ? !matchesParam : matchesParam;
  });
}

function abort(message) {
  console.log(message.red || message);
  process.exit(1);
}

function findPackageSync(packageName) {
  var root = arguments.length <= 1 || arguments[1] === undefined ? process.env.PWD : arguments[1];

  var findModules = require('find-node-modules');
  var path = require('path');

  var moduleDirectories = findModules(root, { relative: false });

  var directory = moduleDirectories.find(function (p) {
    var exists = pathExists((0, _path.join)(p, packageName));
    return exists;
  });

  if (!directory) {
    try {
      var resolvedPath = path.dirname(require.resolve(packageName));
      return resolvedPath;
    } catch (error) {
      //console.log('Error looking up package', packageName, error.message)
    }
  }

  return directory && path.resolve(path.join(directory, packageName));
}

function findPackage(packageName) {
  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  return new _promise2.default(function (resolve, reject) {
    var moduleDirectories = findModules(process.env.PWD, { relative: false });
    var directory = moduleDirectories.find(function (p) {
      var exists = pathExists((0, _path.join)(p, packageName));
      return exists;
    });

    if (!directory) {
      try {
        var resolvedPath = path.dirname(require.resolve(packageName));
        resolve(resolvedPath);
        return;
      } catch (error) {}
    }

    if (!directory) {
      reject(packageName);
    }

    var result = path.resolve(path.join(directory, packageName));

    if (result) {
      resolve(result);
    }
  });
}

function splitPath() {
  var p = arguments.length <= 0 || arguments[0] === undefined ? '' : arguments[0];

  return path.resolve(p).split(path.sep);
}

function skypagerBabel() {
  var presets = findPackageSync('babel-preset-skypager');

  try {
    presets ? require('babel-register')({ presets: presets }) : require('babel-register');
  } catch (error) {
    abort('Error loading the babel-register library. Do you have the babel-preset-skypager package?');
  }
}

function pathExists(fp) {
  var fs = require('fs');
  var fn = typeof fs.access === 'function' ? fs.accessSync : fs.statSync;

  try {
    fn(fp);
    return true;
  } catch (error) {
    return false;
  }
}

function findPackageManifest() {
  var cwd = arguments.length <= 0 || arguments[0] === undefined ? process.env.PWD : arguments[0];

  return require('findup-sync')('package.json', { cwd: cwd });
}

function loadManifestFromDirectory() {
  var cwd = arguments.length <= 0 || arguments[0] === undefined ? process.env.PWD : arguments[0];

  return require('findup-sync')('package.json', { cwd: cwd });
}

function testWithOperator(param, testValue) {
  var operator = param.operator || param.op;
  var checkValue = param.value || param.val;
  var testFn = operators[operator] || isEqual;

  return testFn(testValue, checkValue);
}

module.exports.lodashify = function lodashify() {
  for (var _len2 = arguments.length, methods = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    methods[_key2] = arguments[_key2];
  }

  return function (object) {
    return methods.reduce(function (memo, method) {
      defineProperty(memo, method, {
        configurable: true,
        enumerable: false,
        value: _lodash2.default.partial(_lodash2.default[method], object)
      });

      return memo;
    }, object);
  };
};