import traverse from 'babel-traverse'
import * as t from 'babel-types'

export function indexer(ast, script) {
  let { indexes } = script

  indexes._importNodes = []
  indexes._exportNodes = []
  indexes._classProperties = {}

  let index = 0

  traverse(ast, {
    enter (path) {
      if (t.isClassProperty(path.node)) {
        let key = path.node.key && path.node.key.name

        if(key) {
          indexes._classProperties[key] = path.node
        }
      }

      if(t.isImportDeclaration(path.node)) {
        indexes._importNodes.push(path.node)
      }

      if(t.isExportDeclaration(path.node)) {
        indexes._exportNodes.push(path.node)
      }

      index = index + 1
    }
  })

  return ast
}

export default indexer
